=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class Rate
    attr_accessor :amount

    attr_accessor :amount_local

    attr_accessor :arrives_by

    attr_accessor :attributes

    attr_accessor :carrier_account

    attr_accessor :currency

    attr_accessor :currency_local

    attr_accessor :duration_terms

    attr_accessor :estimated_days

    attr_accessor :messages

    attr_accessor :object_created

    attr_accessor :object_id

    attr_accessor :object_owner

    attr_accessor :provider

    attr_accessor :provider_image_75

    attr_accessor :provider_image_200

    attr_accessor :servicelevel

    attr_accessor :shipment

    attr_accessor :test

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'amount' => :'amount',
        :'amount_local' => :'amount_local',
        :'arrives_by' => :'arrives_by',
        :'attributes' => :'attributes',
        :'carrier_account' => :'carrier_account',
        :'currency' => :'currency',
        :'currency_local' => :'currency_local',
        :'duration_terms' => :'duration_terms',
        :'estimated_days' => :'estimated_days',
        :'messages' => :'messages',
        :'object_created' => :'object_created',
        :'object_id' => :'object_id',
        :'object_owner' => :'object_owner',
        :'provider' => :'provider',
        :'provider_image_75' => :'provider_image_75',
        :'provider_image_200' => :'provider_image_200',
        :'servicelevel' => :'servicelevel',
        :'shipment' => :'shipment',
        :'test' => :'test'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'amount' => :'Object',
        :'amount_local' => :'Object',
        :'arrives_by' => :'Object',
        :'attributes' => :'Object',
        :'carrier_account' => :'Object',
        :'currency' => :'Object',
        :'currency_local' => :'Object',
        :'duration_terms' => :'Object',
        :'estimated_days' => :'Object',
        :'messages' => :'Object',
        :'object_created' => :'Object',
        :'object_id' => :'Object',
        :'object_owner' => :'Object',
        :'provider' => :'Object',
        :'provider_image_75' => :'Object',
        :'provider_image_200' => :'Object',
        :'servicelevel' => :'Object',
        :'shipment' => :'Object',
        :'test' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::Rate` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::Rate`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'amount')
        self.amount = attributes[:'amount']
      end

      if attributes.key?(:'amount_local')
        self.amount_local = attributes[:'amount_local']
      end

      if attributes.key?(:'arrives_by')
        self.arrives_by = attributes[:'arrives_by']
      end

      if attributes.key?(:'attributes')
        if (value = attributes[:'attributes']).is_a?(Array)
          self.attributes = value
        end
      end

      if attributes.key?(:'carrier_account')
        self.carrier_account = attributes[:'carrier_account']
      end

      if attributes.key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.key?(:'currency_local')
        self.currency_local = attributes[:'currency_local']
      end

      if attributes.key?(:'duration_terms')
        self.duration_terms = attributes[:'duration_terms']
      end

      if attributes.key?(:'estimated_days')
        self.estimated_days = attributes[:'estimated_days']
      end

      if attributes.key?(:'messages')
        if (value = attributes[:'messages']).is_a?(Array)
          self.messages = value
        end
      end

      if attributes.key?(:'object_created')
        self.object_created = attributes[:'object_created']
      end

      if attributes.key?(:'object_id')
        self.object_id = attributes[:'object_id']
      end

      if attributes.key?(:'object_owner')
        self.object_owner = attributes[:'object_owner']
      end

      if attributes.key?(:'provider')
        self.provider = attributes[:'provider']
      end

      if attributes.key?(:'provider_image_75')
        self.provider_image_75 = attributes[:'provider_image_75']
      end

      if attributes.key?(:'provider_image_200')
        self.provider_image_200 = attributes[:'provider_image_200']
      end

      if attributes.key?(:'servicelevel')
        self.servicelevel = attributes[:'servicelevel']
      end

      if attributes.key?(:'shipment')
        self.shipment = attributes[:'shipment']
      end

      if attributes.key?(:'test')
        self.test = attributes[:'test']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @amount.nil?
        invalid_properties.push('invalid value for "amount", amount cannot be nil.')
      end

      if @amount_local.nil?
        invalid_properties.push('invalid value for "amount_local", amount_local cannot be nil.')
      end

      if @attributes.nil?
        invalid_properties.push('invalid value for "attributes", attributes cannot be nil.')
      end

      if @carrier_account.nil?
        invalid_properties.push('invalid value for "carrier_account", carrier_account cannot be nil.')
      end

      if @currency.nil?
        invalid_properties.push('invalid value for "currency", currency cannot be nil.')
      end

      if @currency_local.nil?
        invalid_properties.push('invalid value for "currency_local", currency_local cannot be nil.')
      end

      if @object_created.nil?
        invalid_properties.push('invalid value for "object_created", object_created cannot be nil.')
      end

      if @object_id.nil?
        invalid_properties.push('invalid value for "object_id", object_id cannot be nil.')
      end

      if @object_owner.nil?
        invalid_properties.push('invalid value for "object_owner", object_owner cannot be nil.')
      end

      if @provider.nil?
        invalid_properties.push('invalid value for "provider", provider cannot be nil.')
      end

      if @servicelevel.nil?
        invalid_properties.push('invalid value for "servicelevel", servicelevel cannot be nil.')
      end

      if @shipment.nil?
        invalid_properties.push('invalid value for "shipment", shipment cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @amount.nil?
      return false if @amount_local.nil?
      return false if @attributes.nil?
      return false if @carrier_account.nil?
      return false if @currency.nil?
      return false if @currency_local.nil?
      return false if @object_created.nil?
      return false if @object_id.nil?
      return false if @object_owner.nil?
      return false if @provider.nil?
      return false if @servicelevel.nil?
      return false if @shipment.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          amount == o.amount &&
          amount_local == o.amount_local &&
          arrives_by == o.arrives_by &&
          attributes == o.attributes &&
          carrier_account == o.carrier_account &&
          currency == o.currency &&
          currency_local == o.currency_local &&
          duration_terms == o.duration_terms &&
          estimated_days == o.estimated_days &&
          messages == o.messages &&
          object_created == o.object_created &&
          object_id == o.object_id &&
          object_owner == o.object_owner &&
          provider == o.provider &&
          provider_image_75 == o.provider_image_75 &&
          provider_image_200 == o.provider_image_200 &&
          servicelevel == o.servicelevel &&
          shipment == o.shipment &&
          test == o.test
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [amount, amount_local, arrives_by, attributes, carrier_account, currency, currency_local, duration_terms, estimated_days, messages, object_created, object_id, object_owner, provider, provider_image_75, provider_image_200, servicelevel, shipment, test].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
